Unit OFile;
{ Objet fichier gr directement par appel aux fonctions DOS. }
{ En cas d'erreur, aucune opration ne peut plus tre ralise. }
{ De nombreux messages d'erreurs permettent de comprendre l'erreur. }

{ Kostrzewa Bruno }
{ septembre 1994 }

{$IFDEF debug}
 {$A+,B-,D+,E-,F-,I+,L+,N-,R+,S+,V-,W+,X+}
{$ELSE}
 {$A+,B-,D-,E-,F-,I+,L-,N-,R-,S-,V-,W+,X+}
{$ENDIF}

INTERFACE

Uses Dos;   { pour la gestion des noms de fichier et les appels aux
              interruptions }

Const
{ modes d'ouverture des fichiers }
 stCreate     = $0001; { crer un nouveau fichier en crasant si ncessaire
                         un fichier existant }
 stOpen       = $0002; { ouvrir un fichier existant }

{ modes de dplacements dans le fichier }
 dpDebut      = 0;
 dpCourant    = 1;
 dpFin        = 2;

{ constante indiquant qu'aucun Handle n'est attribu au fichier }
 NoHandle     = $FFFF;

Type
  PFile=^TFile;
  TFile=object
   Handle    : Word;      { Handle du DOS }
   ErrorFlag : Word;      { Numro d'erreur DOS }
   FDir      : DirStr;    { Chemin d'accs au fichier }
   FName     : NameStr;   { Nom du fichier }
   FExt      : ExtStr;    { Extension du fichier }
   Constructor Init(Nom:String; Acces:Word);
   { ouverture du fichier }
   Destructor  Done;virtual;
   { fermeture du fichier }
   Procedure FOpen;
   { ouverture d'un fichier existant }
   Procedure FCreate;
   { cration d'un fichier }
   Procedure FClose;
   { fermeture du fichier }
   Procedure FTruncate;
   { termine le fichier  la position actuelle du pointeur }
   Procedure FWriteC(Var Buf; Taille:Word; Var Res:Word);
   { criture dans le fichier avec retour du nombre d'octets crits }
   Procedure FWrite(Var Buf; Taille:Word);        virtual;
   { criture dans le fichier }
   Procedure FReadC(Var Buf; Taille:Word; Var Res:Word);
   { lecture dans le fichier avec retour du nombre d'octets lus }
   Procedure FRead(Var Buf; Taille:Word);         virtual;
   { lecture du fichier }
   Procedure FSeekRel(Depl:LongInt; Mode:Byte);
   { dplacement dans le fichier  partir:
     du dbut pour Mode=dpDebut
     de la position courante pour Mode=dpCourant
     de la fin pour Mode=dpFin }
   Procedure FSeek(Depl:LongInt);
   { dplacement dans le fichier  partir du dbut }
   Function  FSize:LongInt;
   { taille du fichier sur disque }
   Function  FPosit:LongInt;
   { position actuelle dans le fichier }
   Function  IsValid:Boolean;                     virtual;
   { test d'erreur }
   Function  GetErrorMsg:String;                  virtual;
   { renvoie un ventuel message d'erreur }
   End;

IMPLEMENTATION

Type
 { pour le passage des entiers longs aux double-mots }
 LongRec = record
  Faible : Word;
  Fort   : Word;
  End;

Var Regs:Registers;

Function GetDosErrorMsg(code:Word):String;
{ interprtation des codes d'erreur du DOS }
Begin
 case code of
  { 00 pas d'erreur }
  $00 : GetDosErrorMsg:='';

  { 01 le numro de la fonction ou de la sous fonction de l'interruption
    n'est pas valide }
  $01 : GetDosErrorMsg:='Numro de fonction invalide.';

  { 02 le fichier cherch n'a pas t trouv dans le rpertoire spcifi }
  $02 : GetDosErrorMsg:='Fichier non trouv.';

  { 03 le rpertoire spcifi n'a pas t trouv }
  $03 : GetDosErrorMsg:='Chemin non trouv.';

  { 04 trop de fichiers ouverts car un programme ne dispose que de 20 handles }
  $04 : GetDosErrorMsg:='Trop de fichiers ouverts.';

  { 05 accs au fichier refus, par exemple pour criture sur fichier en
    lecture seule }
  $05 : GetDosErrorMsg:='Accs refus.';

  { 06 le handle spcifi ne correspond pas  un fichier ouvert }
  $06 : GetDosErrorMsg:='Handle incorrect.';

  { 07 problme avec la mmoire }
  $07 : GetDosErrorMsg:='Bloc de contrle mmoire dtruit.';

  { 08 mmoire insuffisante, par exemple pour excuter un programme fils }
  $08 : GetDosErrorMsg:='Mmoire insuffisante.';

  { 09 problme avec la mmoire }
  $09 : GetDosErrorMsg:='Adresse de zone incorrecte.';

  { 10 mauvais environnement }
  $0A : GetDosErrorMsg:='Mauvais environnement.';

  { 11 format invalide des donnes }
  $0B : GetDosErrorMsg:='Format incorrect.';

  { 12 code d'accs incorrect, par exemple crire dans un fichier ouvert
    en lecture }
  $0C : GetDosErrorMsg:='Code d''accs incorrect.';

  { 13 donne incorrecte }
  $0D : GetDosErrorMsg:='Donne incorrecte.';

  { 14 rserv }

  { 15 mauvais numro de lecteur }
  $0F : GetDosErrorMsg:='Rfrence de disque incorrecte.';

  { 16 suicide interdit }
  $10 : GetDosErrorMsg:='Tentative de destruction du rpertoire courant.';

  { 17 priphriques diffrents quand on essaie de renommer }
  $11 : GetDosErrorMsg:='Priphriques diffrents.';

  { 18 plus de fichiers lors d'une recherche }
  $12 : GetDosErrorMsg:='Plus de fichiers.';

  { 19 il faut enlever la protection en criture de la disquette ! }
  $13 : GetDosErrorMsg:='Disque protg contre l''criture.';

  { 20 unit non reconnue par le systme }
  $14 : GetDosErrorMsg:='Unit inconnue.';

  { 21 introduire une disquette dans le lecteur ou fermer la porte }
  $15 : GetDosErrorMsg:='Disque pas prt.';

  { 22 problme de matriel }
  $16 : GetDosErrorMsg:='Commande incorrecte.';

  { 23 problme de matriel }
  $17 : GetDosErrorMsg:='Erreur de mmoire.';

  { 24 problme de matriel }
  $18 : GetDosErrorMsg:='Longueur de structure incorrecte.';

  { 25 problme de matriel }
  $19 : GetDosErrorMsg:='Erreur de positionnement du pointeur de fichier.';

  { 26 type de support magntique inconnu }
  $1A : GetDosErrorMsg:='Disque non format.';

  { 27 problme de matriel }
  $1B : GetDosErrorMsg:='Secteur non trouv.';

  { 28 erreur d'imprimante }
  $1C : GetDosErrorMsg:='Plus de papier dans l''imprimante.';

  { 29 problme de matriel }
  $1D : GetDosErrorMsg:='Erreur d''criture.';

  { 30 problme de matriel }
  $1E : GetDosErrorMsg:='Erreur de lecture.';

  { 31 problme matriel }
  $1F : GetDosErrorMsg:='Erreur lie au matriel.';
  else  GetDosErrorMsg:='Erreur non rpertorie.'
  end;
End;

{ Objet TFile }

Constructor TFile.Init(Nom:String; Acces:Word);
Var P : PathStr;
    i : Integer;
    S : SearchRec;
Begin
 ErrorFlag:=0;
 Handle:=NoHandle;
 { retrouver le nom complet et le mettre en majuscules }
 P:=FExpand(Nom);
 for i:=1 to length(P) do P[i]:=UpCase(P[i]);
 { conserver les parties spares }
 FSplit(P,FDir,FName,FExt);
 { ouverture du fichier }
 case Acces of
    stCreate : FCreate;
    stOpen   : FOpen;
    end;
End;

Destructor TFile.Done;
{ on ferme le fichier }
Begin
 FClose;
End;

Procedure TFile.FOpen;
Var P : PathStr;
Begin
 if Handle<>NoHandle  { fichier dj ouvert }
    then begin
          FClose;
          if not IsValid then exit;
         end;
 P:=FDir+FName+FExt+#0;          { Chane  0 terminal pour DOS      }
 Regs.AH:=$3D;                   { Ouvrir fichier existant           }
 Regs.AL:=2;                     { Mode d'accs : Lit/Ecrit          }
 Regs.DS:=Seg(P[1]);             { Adresse du nom ASCII-Z            }
 Regs.DX:=Ofs(P[1]);
 Intr($21,Regs);                 { Invoque le DOS                    }
 if (Regs.Flags and FCarry)<>0   { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX
    else Handle:=Regs.AX;        { Recupre le Handle du fichier     }
End;

Procedure TFile.FCreate;
Var P : PathStr;
Begin
 if Handle<>NoHandle  { fichier dj ouvert }
    then begin
          FClose;
          if not IsValid then exit;
         end;
 P:=FDir+FName+FExt+#0;
 Regs.AH:=$3C;                   { Crer ou vider fichier            }
 Regs.CX:=0;                     { Attribut fichier : fichier normal }
 Regs.DS:=Seg(P[1]);             { Adresse du nom ASCII-Z            }
 Regs.DX:=Ofs(P[1]);
 Intr($21,Regs);                 { Invoque le DOS                    }
 if (Regs.Flags and FCarry)<>0   { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX
    else Handle:=Regs.AX;        { Recupre le Handle du fichier     }
End;

Procedure TFile.FClose;
Begin
 if Handle=NoHandle then exit;   { Fichier dj ferm                 }
 Regs.AH:=$3E;                   { Fonction : fermer le fichier       }
 Regs.BX:=Handle;                { Donne le Handle du fichier         }
 Intr($21,Regs);                 { Invoque le DOS                     }
 if (Regs.Flags and FCarry)<>0   { Test d'erreur                      }
    then ErrorFlag:=Regs.AX;
 Handle:=NoHandle;               { Plus de handle pour le fichier     }
End;

Procedure TFile.FTruncate;
Begin
 if (ErrorFlag<>0) then Exit;
 Regs.AH:=$40;                         { Ecrire dans fichier               }
 Regs.BX:=Handle;                      { Donne le Handle du fichier        }
 Regs.CX:=0;                           { Ecrire 0 octet=truncate           }
 Intr($21,Regs);                       { Invoque le DOS                    }
 If (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FWriteC(Var Buf; Taille:Word; Var Res:Word);
{ criture avec rcupration du nombre d'octets crits dans Res }
Begin
 if (ErrorFlag<>0) or (Taille=0) then Exit;
 Regs.AH:=$40;                         { Ecrire dans fichier               }
 Regs.BX:=Handle;                      { Donne le Handle du fichier        }
 Regs.CX:=Taille;                      { Nombre d'octets  crire          }
 Regs.DS:=Seg(Buf);                    { Adresse de la destination         }
 Regs.DX:=Ofs(Buf);
 Intr($21,Regs);                       { Invoque le DOS                    }
 Res:=Regs.AX;                         { Nombre d'octets crits            }
 If (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FWrite(Var Buf; Taille:Word);
{ criture simple }
Begin
 if ErrorFlag<>0  then Exit;
 Regs.AH:=$40;                         { Ecrire dans fichier               }
 Regs.BX:=Handle;                      { Donne le Handle du fichier        }
 Regs.CX:=Taille;                      { Nombre d'octets  crire          }
 Regs.DS:=Seg(Buf);                    { Adresse de la destination         }
 Regs.DX:=Ofs(Buf);
 Intr($21,Regs);                       { Invoque le DOS                    }
 If (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FReadC(Var Buf; Taille:Word; Var Res:Word);
{ lecture avec rcupration du nombre d'octets lus }
Begin
 if ErrorFlag<>0 then exit;
 Regs.AH:=$3F;                         { Lire le fichier                   }
 Regs.BX:=Handle;                      { Donne la Handle du fichier        }
 Regs.CX:=Taille;                      { Nombre d'octets  lire            }
 Regs.DS:=Seg(Buf);                    { Adresse de la destination         }
 Regs.DX:=Ofs(Buf);
 Intr($21,Regs);                       { Invoque le DOS                    }
 Res:=Regs.AX;                         { Nombre d'octets lus               }
 if (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FRead(Var Buf; Taille:Word);
{ lecture simple }
Begin
 if ErrorFlag<>0 then exit;
 Regs.AH:=$3F;                         { Lire le fichier                   }
 Regs.BX:=Handle;                      { Donne le Handle du fichier        }
 Regs.CX:=Taille;                      { Nombre d'octets  lire            }
 Regs.DS:=Seg(Buf);                    { Adresse de la destination         }
 Regs.DX:=Ofs(Buf);
 Intr($21,Regs);                       { Invoque le DOS                    }
 if (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FSeekRel(Depl:LongInt; Mode:Byte);
{ dplacement relatif du pointeur }
Begin
 if ErrorFlag<>0 then Exit;
 Regs.AH:=$42;                         { Dplacement du pointeur           }
 Regs.AL:=Mode;                        { Mode de calcul du dplacement     }
 Regs.BX:=Handle;                      { Donne le handle du fichier        }
 Regs.CX:=LongRec(Depl).Fort;          { Valeur du dplacement             }
 Regs.DX:=LongRec(Depl).Faible;
 Intr($21,Regs);                       { Invoque le DOS                    }
 if (Regs.Flags and FCarry)<>0         { Test d'erreur DOS                 }
    then ErrorFlag:=Regs.AX;
End;

Procedure TFile.FSeek(Depl:LongInt);
{ positionnement  partir du dbut }
Begin
 FSeekRel(Depl, dpDebut);
End;

Function TFile.FSize:LongInt;
{ calcul de la taille du fichier }
Var t,l:LongInt;
Begin
 FSize:=0;          { rponse par dfaut }
 if ErrorFlag<>0  then Exit;
 t:=FPosit;         { mmorise la position courante du pointeur }
 if ErrorFlag<>0  then Exit;
 { se positionner en fin de fichier }
 Regs.AH:=$42;
 Regs.AL:=dpFin;
 Regs.BX:=Handle;
 Regs.CX:=0;
 Regs.DX:=0;
 Intr($21,Regs);
 { lire la position  partir du dbut }
 LongRec(l).Fort:=Regs.DX;
 LongRec(l).Faible:=Regs.AX;
 { test d'erreur DOS }
 if (Regs.Flags and FCarry)<>0
    then ErrorFlag:=Regs.AX
    else begin
          FSize:=l;
          { rtablir la position initiale }
          FSeekRel(t,dpDebut);
         end;
End;

Function TFile.FPosit:LongInt;
Var l:LongInt;
Begin
 FPosit:=-1;     { rponse par dfaut }
 if ErrorFlag<>0 then exit;
 { se positionner  la position courante }
 Regs.AH:=$42;
 Regs.AL:=dpCourant;
 Regs.BX:=Handle;
 Regs.CX:=0;
 Regs.DX:=0;
 Intr($21,Regs);
 { lire la position  partir du dbut }
 LongRec(l).Fort:=Regs.DX;
 LongRec(l).Faible:=Regs.AX;
 { test d'erreur DOS }
 If (Regs.Flags and FCarry)<>0
    then ErrorFlag:=Regs.AX
    else FPosit:=l;
End;

Function TFile.IsValid:Boolean;
Begin
 IsValid:=ErrorFlag=0;
End;

Function TFile.GetErrorMsg:String;
Begin
 if ErrorFlag<>0
    then GetErrorMsg:=FName+FExt+' : '+GetDosErrorMsg(ErrorFlag)
    else GetErrorMsg:='';
End;

END.

{                          Fin du fichier OFile.Pas                         }
