Unit OTableau;
{ Unit dfinissant un objet tableau  grandeur variable. }
{
  Tous les lments du tableau ont la mme taille,  prciser 
  l'initialisation.
  L'initialisation effectue une rservation de mmoire pour un certain
  nombre d'lments  prciser.
  L'criture dans le tableau se fait de 3 faons :
   1) Procdure Ajouter(Var V)
      La variable V est ajoute  la fin du tableau.
   2) Procedure Ecrire(Var V;i:Integer)
      Change le contenu de l'lment i avec V.
   3) Procedure Intercaler(Var V;i:Integer)
      Ecrit la variable V au rang i, mais en dcalant les lments.
  La lecture se fait avec la procdure Lire(Var V;i:Integer).
  La procdure Trier permet de ranger les lments dans l'ordre
  croissant.
}
{
  Deux objets drivs sont aussi dfinis :
  TTabPtr qui est un tableau de pointeurs; une mthode virtuelle Effacer(p)
  doit indiquer comment librer la mmoire alloue  p.
  TTabStr qui est un tableau de pointeurs sur des chaines de caractres.
}
{ Kostrzewa Bruno }
{ avril-septembre 1994 }

{$IFDEF debug}
 {$A+,B-,D+,E-,F-,I+,L+,N-,R+,S+,V-,W+,X+}
{$ELSE}
 {$A+,B-,D-,E-,F-,I+,L-,N-,R-,S-,V-,W+,X+}
{$ENDIF}

INTERFACE

Const
 erNoMem      = 1;
 erOutOfRange = 2;
 erInitFile   = 3;

 TailleMaxVar = 65519;   { taille maximale d'une variable }

Type
 { pointeur sur une chaine de caractres }
 PString=^String;

 { tableau d'octets utilis par l'objet TTableau }
 TArray=array[1..TailleMaxVar] of Byte;
 PArray=^TArray;

 { objet TTableau : tableau de variables }

 PTableau=^TTableau;
 TTableau=object
  ErrorFlag : Word;
  Constructor Init(Nombre,NInc,Taille:Integer);
  { Le constructeur attend 3 paramtres:
    1) le nombre d'lments pour lesquels on rserve une place
       en mmoire au dpart.
    2) le nombre d'lments pour lesquels on ajoute de la place
       en mmoire en cas de besoin.
    3) la taille en octets d'un lment (utiliser SizeOf) }
  Destructor Done;                                            Virtual;
  { Le destructeur libre la mmoire utilise par le tableau }
  Function GetErrorMsg:String;                                Virtual;
  { Renvoie le message d'erreur }
  Function IsValid:Boolean;
  { indicateur d'erreur }
  Procedure Lire(Var V;i:Integer);
  { Lire l'lment i dans la variable V. }
  Procedure Ecrire(Var V;i:Integer);                          Virtual;
  { Ecrire la variable V dans l'lment i. L'ancien contenu est effac. }
  Procedure Ajouter(Var V);
  { Ajouter la variable V  la fin du tableau. Augmente la taille
    du tableau si ncessaire. }
  Procedure Intercaler(Var V;i:Integer);
  { Faire reculer les lments de rang suprieur ou gal  i d'un cran
    puis placer la variable V dans l'lment i. Augmente la taille
    du tableau si ncessaire. }
  Procedure Eliminer(i:Integer);                              Virtual;
  { Faire reculer les lments de rang suprieur  i d'un cran. L'lment
    de rang i est ainsi effac. }
  Procedure Vider;virtual;
  { Ramne le nombre d'lments  0 }
  Function Compare(i1,i2:Integer):Integer;                    Virtual;
  { Fonction de comparaison  redfinir pour chaque type de variable.
    Cette fonction doit renvoyer un entier ngatif si i1<12, un entier
    positif si i1>12 et 0 si i1=i2. }
  Function NombreItems:Integer;
  { Renvoie le nombre d'lments crits dans le tableau. }
  Procedure Trier(Croissant:Boolean);
  { Classe les lments dans l'ordre croissant en utilisant la fonction
    Compare. }
  Private
   Table:PArray;       { pointeur sur le contenu du tableau }
   TailleItem:Integer; { taille d'un lment }
   NbMax:Integer;      { nombre maximal d'lments sans ajout }
   NbInc:Integer;      { nombre d'lments  ajouter en cas de besoin }
   NbItems:Integer;    { nombre d'lments }
   Procedure Agrandir; { agrandit le tableau de NbInc lments }
  End;

 { objet TTabPtr; tableau de pointeurs }

 PTabPtr=^TTabPtr;
 TTabPtr=object(TTableau)
  Constructor Init(Nombre,NInc:Integer);
  { Le constructeur utilise 2 paramtres :
    1) le nombre d'lments pour lesquels on rserve une place
       en mmoire au dpart.
    2) le nombre d'lments pour lesquels on ajoute de la place
       en mmoire en cas de besoin.
    La taille d'un lment est SizeOf(Pointer) puisque les lments
    sont des pointeurs }
  Destructor Done;                                              Virtual;
  { Le destructeur libre la mmoire alloue aux pointeurs et la
    mmoire alloue au tableau }
  Procedure Effacer(p:Pointer);                                 Virtual;
  { Procdure virtuelle  rcrire OBLIGATOIREMENT pour indiquer
    comment librer la mmoire alloue  un pointeur }
  Procedure Eliminer(i:Integer);                                Virtual;
  { Elimination de l'lment i avec libration de la mmoire alloue }
  Procedure Vider;                                              Virtual;
  { Elimination de tous les lments }
  Procedure Changer(i:Integer;p:Pointer);
  { Ecrire p en i avec limination pralable de la mmoire prcdemment
    alloue au pointeur de rang i }
  End;

 { objet TStrTab : tableau de chaines de caractres }

 PStrTab=^TStrTab;
 TStrTab=object(TTabPtr)
  Constructor Init(Nombre,NInc:Integer);
  { Initialisation d'un tableau vide }
  Constructor Load(NomDeFichier:String);
  { Initialisation  partir d'un fichier texte }
  Procedure Save(NomDeFichier:String);
  { Sauvegarde dans un fichier texte }
  Procedure Effacer(p:Pointer);virtual;
  { libration de la mmoire alloue  un pointeur sur chaine
    de caractres }
  Function Compare(i1,i2:Integer):Integer;virtual;
  { comparaison de 2 chaines de caractres }
  Procedure AjouterLigne(S:String);
  { Ajouter une chaine de caractres en fin de tableau }
  Procedure PlacerLigne(S:String;i:Integer);
  { Intercaler une chaine de caractres au rang i }
  Procedure ChangerLigne(i:Integer;s:String);
  { Changer la chaine de caractres pointe au rang i }
  Function Ligne(i:Integer):String;
  { Renvoyer la chaine de caractres de rang i }
  End;

IMPLEMENTATION

{ ==== objet TTableau ==== }

Constructor TTableau.Init(Nombre,NInc,Taille:Integer);
Begin
 { initialisation des variables utilises }
 ErrorFlag:=0;
 NbMax:=Nombre;
 NbInc:=NInc;
 TailleItem:=Taille;
 NbItems:=0;  { aucun lment crit au dpart }
 { rservation de mmoire }
 GetMem(Table,word(NbMax*TailleItem));
 if Table=nil
    then ErrorFlag:=erNoMem
    else FillChar(Table^,word(NbMax*TailleItem),0);
End;

Destructor TTableau.Done;
Begin
 { librer la mmoire utilise }
 if Table<>nil
    then FreeMem(Table,word(NbMax*TailleItem));
End;

Function TTableau.GetErrorMsg:String;
Begin
 case ErrorFlag of
  erNoMem :
   GetErrorMsg:='Mmoire insuffisante pour cette opration.';
  erOutOfRange :
   GetErrorMsg:='Trop d''lments dans le tableau.';
  else GetErrorMsg:='';
  end;
End;

Function TTableau.IsValid:Boolean;
Begin
 IsValid:=ErrorFlag=0;
End;

Procedure TTableau.Lire(Var V;i:Integer);
Begin
 if (i>=1) and (i<=NbItems)
    then move(Table^[word((i-1)*TailleItem+1)],V,TailleItem);
End;

Procedure TTableau.Ecrire(Var V;i:Integer);
Begin
 if (i>=1) and (i<=NbItems)
    then move(V,Table^[word((i-1)*TailleItem+1)],TailleItem);
End;

Procedure TTableau.Ajouter(Var V);
Begin
 if NbItems=NbMax   { fin actuelle du tableau atteinte }
    then Agrandir;  { il faut agrandir }
 if IsValid
    then begin
          inc(NbItems);
          move(V,Table^[word((NbItems-1)*TailleItem+1)],TailleItem);
         end;
End;

Function TTableau.NombreItems:Integer;
Begin
 NombreItems:=NbItems;
End;

Procedure TTableau.Agrandir;
Var copie:PArray;
Begin
 if NbMax+NbInc>TailleMaxVar div TailleItem  { tableau trop grand }
    then begin
          ErrorFlag:=erOutOfRange;
          exit;
         end;
 { rservation mmoire pour le nouveau tableau }
 GetMem(copie,word((NbMax+NbInc)*TailleItem));
 if copie=nil   { pas assez de mmoire }
    then begin
          ErrorFlag:=erNoMem;
          exit;
         end;
 { recopier l'ancien tableau dans le nouveau }
 move(table^,copie^,word(NbMax*TailleItem));
 { complter avec des 0 }
 FillChar(copie^[word(NbMax*TailleItem+1)],word(NbInc*TailleItem),0);
 { librer la mmoire utilise par l'ancien tableau }
 FreeMem(Table,word(NbMax*TailleItem));
 { le nouveau tableau devient le tableau actuel }
 Table:=copie;
 { mise  jour du nombre maximal d'lments }
 NbMax:=NbMax+NbInc;
End;

Procedure TTableau.Eliminer(i:Integer);
Begin
 if (i<1) or (i>NbItems)
    then exit;
 { dplacer le tableau de la taille d'une variable  partir
   du rang i+1 }
 move(Table^[word(i*TailleItem+1)],Table^[word((i-1)*TailleItem+1)],
      word((NbItems-i)*TailleItem));
 { remplir le dernier lment avec des 0 }
 FillChar(Table^[word((NbItems-1)*TailleItem+1)],TailleItem,0);
 { mise  jour du nombre d'lments }
 dec(NbItems);
End;

Procedure TTableau.Vider;
Begin
 { remplir le tableau avec des 0 }
 FillChar(Table^,word(NbMax*TailleItem),0);
 { nombre d'lments gal  0 }
 NbItems:=0;
End;

Procedure TTableau.Intercaler(Var V;i:Integer);
Begin
 if (i=0) or (i>NbItems+1)
    then exit;
 { si i indique la fin du tableau on ajoute l'lment }
 if i=NbItems+1
    then begin
          Ajouter(V);
          exit;
         end;
 { faut-il agrandir le tableau ? }
 if NbItems=NbMax
    then Agrandir;
 if IsValid
    then begin
          { dcaler le tableau d'une variable vers la droite  partir
            du rang i }
          move(Table^[word((i-1)*TailleItem+1)],Table^[word(i*TailleItem+1)],
               word((NbItems-i+1)*TailleItem));
          { crire V }
          move(V,Table^[word((i-1)*TailleItem+1)],TailleItem);
          { mise  jour du nombre d'lments }
          inc(NbItems);
         end;
End;

Function TTableau.Compare(i1,i2:Integer):Integer;
Begin
 Compare:=0;
 { fonction virtuelle  redfinir pour utiliser la procdure Trier }
 { compare=0 en cas d'galit }
 { compare<0 si item(i1)<item(i2) }
 { compare>0 si item(i1)>item(i2) }
End;

Procedure TTableau.Trier(Croissant:Boolean);
Var tmp:PArray; { zone de stockage pour changes }

 Procedure QuickSort(a,b:Integer);
 Var m:Integer;

  Function Partition(a,b:Integer):Integer;
  Var dernier,k:Integer;

   Procedure Swap(i,j:Integer);
   Begin
    { sauver l'lment i dans tmp }
    move(Table^[word((i-1)*TailleItem+1)],tmp^,TailleItem);
    { crire l'lment j dans l'lment i }
    move(Table^[word((j-1)*TailleItem+1)],Table^[word((i-1)*TailleItem+1)],
                TailleItem);
    { crire tmp dans l'lment j }
    move(tmp^,Table^[word((j-1)*TailleItem+1)],TailleItem);
   End;

  Begin  {partition}
   swap(a,(a+b) div 2);
   dernier:=a;
   for k:=a+1 to b do
     if croissant
        then begin
              if compare(k,a)<0
                 then begin
                       Swap(dernier+1,k);
                       dernier:=dernier+1;
                      end;
             end
        else begin
              if compare(k,a)>0
                 then begin
                       Swap(dernier+1,k);
                       dernier:=dernier+1;
                      end;
             end;
   swap(dernier,a);
   partition:=dernier;
  End;

 Begin  {quicksort}
  if a<b
     then begin
           m:=partition(a,b);
           quicksort(a,m-1);
           quicksort(m+1,b);
          end;
 End;

Begin  {trier}
 getmem(tmp,TailleItem);
 quicksort(1,NbItems);
 freemem(tmp,TailleItem);
End;

{ ==== objet TTabPtr ==== }

Constructor TTabPtr.Init(Nombre,NInc:Integer);
Begin
 { appel au constructeur hrit }
 TTableau.Init(Nombre,NInc,sizeof(Pointer));
End;

Destructor TTabPtr.Done;
Begin
 { librer la mmoire alloue aux pointeurs du tableau }
 if IsValid
    then Vider;
 { destructeur hrit }
 TTableau.Done;
End;

Procedure TTabPtr.Effacer(p:Pointer);
Begin
 { procdure virtuelle  redfinir obligatoirement }
 { pour indiquer la faon de librer la mmoire    }
 { alloue aux pointeurs }
End;

Procedure TTabPtr.Vider;
Var i:Integer;
    p:Pointer;
Begin
 { librer la mmoire alloue aux pointeurs }
 if NombreItems>0
    then for i:=1 to NombreItems do
     begin
      Lire(p,i);
      Effacer(p);
      p:=nil;
      Ecrire(p,i);
     end;
 { ramener le nombre d'lments  0 }
 TTableau.Vider;
End;

Procedure TTabPtr.Eliminer(i:Integer);
Var p:Pointer;
Begin
 if (i<1) or (i>NombreItems)
    then exit;
 { librer la mmoire alloue }
 Lire(p,i);
 Effacer(p);
 { limination }
 TTableau.Eliminer(i);
End;

Procedure TTabPtr.Changer(i:Integer;p:Pointer);
Var w:Pointer;
Begin
 if (i<1) or (i>NombreItems)
    then exit;
 { librer la mmoire alloue }
 Lire(w,i);
 Effacer(w);
 { crire le nouveau pointeur }
 Ecrire(p,i);
End;

{ ==== objet TStrTab ==== }

Constructor TStrTab.Init(Nombre,NInc:Integer);
Begin
 { appel au constructeur hrit }
 TTabPtr.Init(Nombre,NInc);
End;

Constructor TStrTab.Load(NomDeFichier:String);
Var f:Text;
    s:String;
Begin
 { appel au constructeur hrit }
 TTabPtr.Init(100,100);
 if not IsValid
    then exit;
 { ouverture du fichier }
 assign(f,NomDeFichier);
 {$I-}
 reset(f);
 {$I+}
 if IOResult<>0
    then begin
          ErrorFlag:=erInitFile;
          exit;
         end;
 while not EOF(f) and IsValid do
  begin
   { lire une ligne }
   readln(f,s);
   { ajouter la ligne dans le tableau }
   AjouterLigne(s);
  end;
 { fermeture du fichier }
 close(f);
End;

Procedure TStrTab.Save(NomDeFichier:String);
Var f:Text;
    i:Integer;
Begin
 { ouverture du fichier }
 assign(f,NomDeFichier);
 {$I-}
 rewrite(f);
 {$I+}
 if IOResult<>0
    then begin
          ErrorFlag:=erInitFile;
          exit;
         end;
 { criture dans le fichier }
 for i:=1 to NombreItems do writeln(f,Ligne(i));
 { fermeture du fichier }
 close(f);
End;

Procedure TStrTab.Effacer(p:Pointer);
Begin
 { libration de la mmoire alloue  un pointeur sur chaine de
   caractres }
 if p<>nil
    then FreeMem(P,length(PString(P)^)+1);
End;

Function TStrTab.Compare(i1,i2:Integer):Integer;
Var p1,p2:PString;
Begin
 { lecture des pointeurs sur chaines de caractres }
 Lire(p1,i1);
 Lire(p2,i2);
 { comparaison }
 if p1^<p2^
    then compare:=-1
    else if p1^>p2^
            then compare:=1
            else compare:=0;
End;

Function TStrTab.Ligne(i:Integer):String;
Var p:PString;
Begin
 if (i<1) or (i>NombreItems)
    then begin
          Ligne:='';
          exit;
         end;
 { lecture du pointeur }
 Lire(p,i);
 { renvoi de la chaine pointe }
 if p<>nil
    then Ligne:=p^
    else Ligne:='';
End;

Procedure TStrTab.AjouterLigne(S:String);
Var p:PString;
Begin
 { allocation mmoire au pointeur sur la chaine de caractres }
 GetMem(p,length(s)+1);
 if p=nil
    then ErrorFlag:=erNoMem
    else begin
          { criture de la chaine en mmoire }
          p^:=s;
          { ajouter le pointeur au tableau }
          Ajouter(p);
         end;
End;

Procedure TStrTab.ChangerLigne(i:Integer; S:String);
Var p:PString;
Begin
 { allocation mmoire au pointeur sur la chaine de caractres }
 GetMem(p,length(s)+1);
 if p=nil
    then ErrorFlag:=erNoMem
    else begin
          { criture de la chaine en mmoire }
          p^:=s;
          { changer l'ancien pointeur }
          Changer(i,p);
         end;
End;

Procedure TStrTab.PlacerLigne(S:String; i:Integer);
Var p:PString;
Begin
 { allocation mmoire au pointeur sur chaine de carctres }
 GetMem(p,length(s)+1);
 if p=nil
    then ErrorFlag:=erNoMem
    else begin
          { crire la chaine en mmoire }
          p^:=s;
          { intercaler le pointeur }
          Intercaler(p,i);
         end;
End;

END.

{                       Fin du fichier OTableau.Pas                         }
