Unit UDrivers;
{ drivers clavier, souris }
{ K.B. octobre-novembre 1994 }

{$IFDEF debug}
 {$A+,B-,D+,E-,F-,I+,L+,N-,R+,S+,V-,W+,X+}
{$ELSE}
 {$A+,B-,D-,E-,F-,I+,L-,N-,R-,S-,V-,W+,X+}
{$ENDIF}

INTERFACE

Uses Dos;

Const

{ Constantes pour mesure du temps  partir des tics de l'ordinateur }
  TixPerSecond : Real = 1193180 / 65536;
  TixPerDay = $1800B0;
  MouseTempo:Byte = 5;

{ Constantes codes clavier de type Word }
  Echap=$1B;  CsUp =$148; CsDn =$150; CsLf =$14B; CsRg =$14D;
  Suppr=$153; Home =$147; Fin  =$14F; BSP  =$8;  Inser =$152;
  PgUp =$149; PgDn =$151;
  Ret  =$D;   Tab  =$9;   Space=$20;  STab =$10F;
  CPgUp=$184; CPgDn=$176; CCsLf=$173; CCsRg=$174;
  CFin =$175; CHome=$177; CSuppr=$106;
  AltQ =$110; AltW =$111; AltE =$112; AltR =$113; AltT =$114;
  AltZ =$115; AltU =$116; AltI =$117; AltO =$118; AltP =$119;
  AltA =$11E; AltS =$11F; AltD =$120; AltF =$121; AltG =$122;
  AltH =$123; AltJ =$124; AltK =$125; AltL =$126; AltY =$12C;
  AltX =$12D; AltC =$12E; AltV =$12F; AltB =$130; AltN =$131;
  AltM =$132;
  CtrlQ=$11; CtrlW =$17; CtrlE =$5;  CtrlR =$12; CtrlT =$14;
  CtrlZ=$1A; CtrlU =$15; CtrlI =$9;  CtrlO =$F;  CtrlP =$10;
  CtrlA=$1;  CtrlS =$13; CtrlD =$4;  CtrlF =$6;  CtrlG =$7;
  CtrlH=$8;  CtrlJ =$A;  CtrlK =$B;  CtrlL =$C;  CtrlY =$19;
  CtrlX=$18; CtrlC =$3;  CtrlV =$16; CtrlB =$2;  CtrlN =$E;
  CtrlM=$D;
  Alt1 =$178; Alt2 =$179; Alt3 =$17A; Alt4 =$17B; Alt5 =$17C;
  Alt6 =$17D; Alt7 =$17E; Alt8 =$17F; Alt9 =$180; Alt0 =$181;
  F1   =$13B; F2   =$13C; F3   =$13D; F4   =$13E; F5   =$13F;
  F6   =$140; F7   =$141; F8   =$142; F9   =$143; F10  =$144;
  SF1  =$154; SF2  =$155; SF3  =$156; SF4  =$157; SF5  =$158;
  SF6  =$159; SF7  =$15A; SF8  =$15B; SF9  =$15C; SF10 =$15D;
  CF1  =$15E; CF2  =$15F; CF3  =$160; CF4  =$161; CF5  =$162;
  CF6  =$163; CF7  =$164; CF8  =$165; CF9  =$166; CF10 =$167;
  AF1  =$168; AF2  =$169; AF3  =$16A; AF4  =$16B; AF5  =$16C;
  AF6  =$16D; AF7  =$16E; AF8  =$16F; AF9  =$170; AF10 =$171;

{ couleurs }
 Noir:Byte=0;           Gris:Byte=8;
 Bleu:Byte=1;           BleuClair:Byte=9;
 Vert:Byte=2;           VertClair:Byte=10;
 Cyan:Byte=3;           CyanClair:Byte=11;
 Rouge:Byte=4;          RougeClair:Byte=12;
 Magenta:Byte=5;        MagentaClair:Byte=13;
 Brun:Byte=6;           Jaune:Byte=14;
 GrisClair:Byte=7;      Blanc:Byte=15;

{ constantes types d'vnements }
 evNothing    = $0000;
 evMouseLDown = $0001;
 evMouseLUp   = $0002;
 evMouseRDown = $0004;
 evMouseRUp   = $0008;
 evDoubleClic = $0010;
 evMouseAct   = evMouseLDown+evMouseLUp+evMouseRDown+evMouseRUp+evDoubleClic;
 evMouseMove  = $0020;
 evMouseAuto  = $0040;
 evMouse      = evMouseAct+evMouseMove+evMouseAuto;
 evKeyDown    = $0080;
 evCommand    = $0100;
 evMessage    = $0200;
 evProgram    = evCommand+evMessage;

Type
 TPoint = record
           X,Y : Integer;
          end;

 TEvent = record                      { Type vnement           }
           What  : Word;              { Nature de l'vnement    }
           case Word of               { Puis le contenu          }
            evNothing: ();            { Evnement vide           }
            evMouse: (                { Evnement souris         }
             LButton: Boolean;        { Etat bouton de gauche    }
             RButton: Boolean;        { Etat bouton de droite    }
             Where  : TPoint);        { Position de la souris    }
            evKeyDown: (              { Evnement clavier        }
             KeyCode:Word);           { Code de la touche        }
            evProgram: (              { Commande interne         }
             Command: Word;           { No de la commande        }
            case Word of              { Champ info :             }
             0:(InfoByte : Byte);     { de type Byte             }
             1:(InfoInt  : Integer);  { de type Integer          }
             2:(InfoPtr  : Pointer)); { de type Pointer          }
          end;

 PMouseAspect = ^TMouseAspect;
 TMouseAspect = record
                 DX,DY : Integer;
                 cAND  : Array[1..16] Of Word;
                 cOR   : Array[1..16] Of Word;
                end;

Const
 { pointeurs souris }
 PointeurNormal: tMouseAspect=(  Dx:0;Dy:0;
         cAND: ($3FFF,$1FFF,$0FFF,$07FF,$03FF,$01FF,$00FF,$007F,                    { 0000000001111111 }
                      $003F,$001F,$01FF,$30FF,$70FF,$F87F,$F87F,$FC7F);                   { 1111110001111111 }
         cOR : ($0000,$4000,$6000,$7000,$7800,$7C00,$7E00,$7F00,                    { 0111111110000000 }
                      $7F80,$6C00,$4C00,$0600,$0600,$0300,$0300,$0000));
 PointeurGomme: tMouseAspect=(  Dx:8;Dy:8;
        cAND: ($0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,
                     $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000);
        cOR : ($0000,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,
                     $7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$0000));
 PointeurCiseaux: tMouseAspect=(  Dx:0;Dy:0;
        cAND: ($7DFF,$3CFF,$1C7F,$0C7F,$847F,$C07F,$E07F,$F07F,
                       $F871,$FC20,$F800,$E000,$E000,$E041,$E07F,$F0FF);
        cOR : ($0000,$0000,$4100,$6100,$3100,$1900,$0D00,$0400,
                       $0100,$0000,$014C,$017C,$0620,$0600,$0000,$0000));
 PointeurDoigt: tMouseAspect=(  Dx:4;Dy:0;
        cAND: ($F3FF,$E1FF,$E1FF,$E1FF,$E001,$E000,$E000,$E000,
                    $8000,$0000,$0000,$0000,$0000,$0000,$8001,$C003);
        cOR : ($0C00,$1200,$1200,$1200,$13FE,$1249,$1249,$1249,
                    $7249,$9001,$9001,$9001,$8001,$8001,$4002,$3FFC));
 PointeurDoigt2:TMouseAspect=(  DX:5;   DY:0;
        cAND: ($F3FF,$EdFF,$EdFF,$EdFF,$Ec01,$Edb6,$Edb6,$Edb6,                    { 1110110110110110 }
                    $8db6,$6ffe,$6ffe,$6ffe,$7ffe,$7ffe,$bffd,$C003);                   { 1100000000000011 }
        cOR: ($0C00,$1200,$1200,$1200,$13FE,$1249,$1249,$1249,
                    $7249,$9001,$9001,$9001,$8001,$8001,$4002,$3FFC));
 PointeurMain: tMouseAspect=( Dx:8;Dy:8;
        cAND: ($F24F,$E001,$E000,$E000,$E000,$E000,$E000,$8000,
                    $0000,$0000,$0000,$0000,$0000,$0000,$8001,$8001);
        cOR : ($0000,$0DB0,$0DB6,$0DB6,$0DB6,$0DB6,$0DB6,$0DB6,
                    $6FFE,$6FFE,$6FFE,$6FFE,$7FFE,$7FFE,$3FFC,$0000));
 PointeurPhoto: tMouseAspect=(  Dx:8;Dy:8;
        cAND: ($FFFF,$FFFF,$FC3F,$C81F,$8001,$0000,$0000,$0000,
                     $0000,$0000,$0000,$0000,$0000,$0000,$0000,$8001);
        cOR : ($0000,$0000,$0000,$03C0,$37E0,$781E,$7E7E,$781E,
                     $704E,$706E,$706E,$70CE,$781E,$7FFE,$7FFE,$0000));
 PointeurStylo: tMouseAspect=(  Dx:1;Dy:15;
        cAND: ($FFCF,$FF87,$FF03,$FE01,$FC03,$F807,$F00F,$E01F,
                     $C03F,$807F,$00FF,$01FF,$03FF,$07FF,$0FFF,$9FFF);
        cOR : ($0000,$0030,$0078,$009C,$01E8,$03F0,$07E0,$0FC0,
                     $1F80,$2700,$7A00,$5C00,$4800,$5000,$6000,$0000));

Var
 MouseX      : Integer;
 MouseY      : Integer;           { Position courante de la souris }
 MouseStatus : Integer;           { Etat des boutons }
 MouseTix    : LongInt;
 MouseCur    : PMouseAspect;      { Aspect de la souris }
 MouseOk     : Boolean;           { Souris installe }

 OKSound     : Boolean;

 LastVideoMode : Word;            { Mode vido d'origine }

 AppPath     : PathStr;           { Chemin de l'application }
 AppName     : NameStr;

 EventStock  : TEvent;            { Evnement logiciel }

 ClockTix    : Longint absolute $0040:$006C;

Const
 MouseText   : Boolean = false;   { Souris mode texte }
 MouseXShift : Byte = 1;          { coefficient multiplicateur pour }
 MouseYShift : Byte = 1;          { coordonnes souris }

Procedure DriversInit;
Procedure DriversDone;

{ Carte vido }
Procedure SetVideoMode(M : Byte);
Procedure GetVideoMode(var ModeVideo:Word);
Function  IsVga : Boolean;

{ Clavier }
Function IsKeyPressed:Boolean;
Function GetReadKey:Word;

{ Routines de manipulation souris }
Procedure ChangeMouseAspect(M : PMouseAspect);
Procedure MouseClipON(X1,Y1,X2,Y2 : Integer);
Procedure MouseClipOFF;
Procedure MouseHide;
Procedure MouseShow;
Procedure MouseLimits(X1,Y1,X2,Y2 : Integer);
Procedure MouseMoveTo(X,Y : Integer);

{ Routine sonore }
Procedure BeepWrong;

{ Routine de temporisation }
Procedure Wait(n:Word);
{ attend pendant n*1000 boucles vides }

{ Manipulation des chaines de caractres }
Procedure Ajuste(Var S:String;l:Byte);
{ complte avec des espaces pour obtenir la longueur l }
Procedure Majuscule(Var S:String);
{ met la chaine S en majuscules }

{ Routines d'acquisition des vnements }
Procedure GetMouseEvent(Var Event:TEvent);
Procedure GetKeyboardEvent(Var Event:TEvent);
Procedure SetEvent(Event:TEvent);
Procedure ReadEvent(Var Event:TEvent);

IMPLEMENTATION

Var
 Reg : Registers;   { utilis pour les appels aux interruptions DOS }

 ClipX1,ClipY1   : Integer;  { Zone o la souris s'efface }
 ClipX2,ClipY2   : Integer;
 ClipNiveau      : Integer;  { Niveaux d'imbrication des Clip }

{ ==== Module Chaines de caractres ==== }

Procedure Ajuste(Var S:String;l:Byte);
Begin
 if length(S)<l
    then FillChar(S[length(S)+1],l-length(S),32);
 S[0]:=chr(l);
End;

Procedure Majuscule(Var S:String);
Var i:Byte;
Begin
 for i:=1 to length(S) do
  S[i]:=upcase(S[i]);
End;

{ ==== Module Carte Vido ==== }

Procedure SetVideoMode(M : Byte);
{ modification du mode vido }
Begin
 Reg.AH:=00;   {fonction 0, "modification du mode vido"}
 Reg.AL:=M;
 intr($10,Reg);
End;

Procedure GetVideoMode(var ModeVideo:Word);
Begin
 Reg.AH := $0F;                                { Numro de la fonction }
 Intr($10, Reg);              { Dclenche l'interruption vido du BIOS }
 ModeVideo := Reg.AL;                           { Numro du mode vido }
 {NbCol := Reg.ah;}                   { Nombre de caractres par ligne }
 {Page := Reg.bh;}                { Numro de la page d'cran courante }
End;

Function IsVga : Boolean; Assembler;
{ vrification de l'existence d'une carte VGA }
Asm
  MOV AH, 12h  {fonction 12h, sous-fonction 36h}
  MOV AL, 00h  {00 pour activer}
  MOV BL, 36h  {"active/dsactive le rafrachissement de l'cran"}
  INT 10h
  MOV AH, 0    {retourne FALSE}
  CMP AL, 12h  {AL=12h si succs}
  JNZ @NotVga
  INC AH       {retourne TRUE}
  @NotVga:
End;

{ ==== Module Souris ==== }

Procedure MouseMoveTo(X,Y:Integer);
Begin
 if not MouseOK
    then exit;
 Reg.AX:=4;
 Reg.CX:=X;
 Reg.DX:=Y;
 if MouseText
    then begin
          Reg.CX:=Reg.CX*MouseXShift;
          Reg.DX:=Reg.DX*MouseYShift;
         end;
 intr($33,Reg);
End;

Procedure MouseLimits(X1,Y1,X2,Y2 : Integer);
Begin
 if not MouseOK
    then exit;
 Reg.AX:=7;
 Reg.CX:=X1*MouseXShift;
 Reg.DX:=X2*MouseXShift;
 intr($33,Reg);
 Reg.AX:=8;
 Reg.CX:=Y1*MouseYShift;
 Reg.DX:=Y2*MouseYShift;
 intr($33,Reg);
End;

Procedure MouseHide;
Begin
 if not MouseOK
    then exit;
 if ClipNiveau=0
    then begin
          Reg.AX:=2;
          intr($33,Reg);
         end;
 inc(ClipNiveau);
End;

Procedure MouseShow;
Begin
 if not MouseOK
    then exit;
 Dec(ClipNiveau);
 if ClipNiveau=0
    then begin
          Reg.AX:=1;
          intr($33,Reg);
         end;
End;

Procedure ChangeMouseAspect(M:PMouseAspect);
Begin
 if not MouseOk or MouseText then exit;
 if (M<>MouseCur) and (M<>nil)
    then begin
          Reg.AX:=9;
          Reg.BX:=M^.DX;
          Reg.CX:=M^.DY;
          Reg.ES:=Seg(M^.cAND);
          Reg.DX:=Ofs(M^.cAND);
          Intr($33,Reg);
          MouseCur:=M;
         end;
End;

Procedure MouseClipON(X1,Y1,X2,Y2:Integer);

  Function Min(a,b:Integer):Integer;
  Begin
   if a<b then Min:=a else Min:=b;
  End;

  Function Max(a,b:Integer):Integer;
  Begin
   if a<b then Max:=b else Max:=a;
  End;

Begin
 if not MouseOK
    then exit;
 if ClipNiveau=0
    then begin
          ClipX1:=X1;
          ClipY1:=Y1;
          ClipX2:=X2;
          ClipY2:=Y2;
         end
    else begin
          ClipX1:=Min(X1,ClipX1);
          ClipX2:=Max(X2,ClipX2);
          ClipY1:=Min(Y1,ClipY1);
          ClipY2:=Max(Y2,ClipY2);
         end;
 with Reg do
  begin
   AX:=$10;
   CX:=ClipX1*MouseXShift;
   DX:=ClipY1*MouseYShift;
   SI:=ClipX2*MouseXShift;
   DI:=ClipY2*MouseYShift;
  end;
 intr($33,Reg);
 inc(ClipNiveau);
End;

Procedure MouseClipOFF;
Begin
 if not MouseOK
    then exit;
 Dec(ClipNiveau);
 if ClipNiveau=0
    then begin
          Reg.AX:=1;
          intr($33,Reg);
         end;
 MouseMoveTo(MouseX,MouseY);
End;

Procedure MouseInit;
Begin
 MouseStatus:=0;
 MouseX:=0;
 MouseY:=0;
 MouseTix:=0;
 MouseCur:=nil;
 ClipNiveau:=1;
 with Reg do
   begin
    AX:=0;
    intr($33,Reg);
    if AX=0
       then begin
             MouseOK:=false;
             exit;
            end
       else MouseOK:=true;
   end;
 if MouseText
    then begin
          MouseXShift:=8;
          MouseYShift:=8;
         end;
End;

Procedure MouseDone;
Begin
 if not MouseOK
    then exit;
 MouseHide;
 Reg.AX:=0;
 intr($33,Reg);
End;

{ === Module : Clavier === }

Procedure KeyboardInit;
Begin
End;

Function IsKeypressed:Boolean;
Begin
 Reg.AH:=1;
 intr($16,Reg);
 if (Reg.Flags and FZero = 0)
    then IsKeyPressed:=true
    else IsKeyPressed:=false;
End;

Function GetReadKey:Word;
Begin
 Reg.AH:=0;
 intr($16,Reg);
 if Reg.AL=0
    then GetReadKey:=Reg.AH or $100
    else GetReadKey:=Reg.AL;
End;

Procedure KeyboardDone;
Var c:Word;
Begin
 while IsKeyPressed
  do c:=GetReadKey;
End;

{ ==== Module : Son ==== }

Procedure BeepWrong;
Begin
 if OKSound
    then write(#7,#7);
End;

{ ==== Module : Temps ==== }
Procedure Wait(n:Word);
Var Dif,FinTix,DebTix:LongInt;
Begin
 DebTix:=ClockTix;
 repeat
  FinTix:=ClockTix;
  if FinTix<DebTix
     then FinTix:=FinTix+TixPerDay;
  Dif:=FinTix-DebTix;
 until Dif>=n;
End;

{ ==== Gestion des vnements ==== }

Procedure GetMouseEvent(Var Event : TEvent);
Var OldMouseTix : LongInt;
Begin
 Event.What:=evNothing;
 if not MouseOK
    then exit;
 Reg.AX:=3;
 Intr($33,Reg);
 Event.LButton:=(Reg.BX and 1)<>0;
 Event.RButton:=(Reg.BX and 2)<>0;
 if MouseText
    then begin
          Event.Where.X:=Reg.CX div 8;
          Event.Where.Y:=Reg.DX div 8;
         end
    else begin
          Event.Where.X:=Reg.CX;
          Event.Where.Y:=Reg.DX;
         end;
 { la souris a-t-elle chang de place ? }
 if (Event.Where.X<>MouseX) or (Event.Where.Y<>MouseY)
    then begin
          MouseX:=Event.Where.X;
          MouseY:=Event.Where.Y;
          Event.What:=evMouseMove;
         end;
 { test bouton gauche }
 if (MouseStatus and 1)<>(Reg.BX and 1)
    then if (MouseStatus and 1)<>0
            then begin
                   MouseStatus:=MouseStatus xor 1;
                   Event.What:=evMouseLUp;
                  end
            else begin
                  OldMouseTix:=MouseTix;
                  MouseTix:=ClockTix;
                  MouseStatus:=MouseStatus or 1;
                  if abs(MouseTix-OldMouseTix)<MouseTempo
                     then Event.What:=evDoubleClic
                     else Event.What:=evMouseLDown;
                 end;
  { test bouton droit }
  if (MouseStatus and 2)<>(Reg.BX and 2)
     then if (MouseStatus and 2)<>0
             then begin
                   MouseStatus:=MouseStatus xor 2;
                   Event.What:=evMouseRUp;
                  end
             else begin
                   MouseStatus:=MouseStatus or 2;
                   Event.What:=evMouseRDown;
                  end;
End;

Procedure GetKeyboardEvent(Var Event : TEvent);
Begin
 Event.What:=evNothing;
 if IsKeyPressed
    then begin
          Event.What:=evKeyDown;
          Event.KeyCode:=GetReadKey;
         end;
End;

Procedure SetEvent(Event:TEvent);
Begin
 EventStock:=Event;
End;

Procedure ReadEvent(Var Event:TEvent);
Begin
 Event.What:=evNothing;
 if EventStock.What<>evNothing
    then begin
          Event:=EventStock;
          EventStock.What:=evNothing;
         end
    else begin
          GetMouseEvent(Event);
          if Event.What=evNothing
             then begin
                   GetKeyboardEvent(Event);
                   if (Event.What=evNothing) and (MouseStatus<>0)
                      then Event.What:=evMouseAuto;
                  end;
         end;
End;

{ ==== Gestion de l'Unit Drivers ==== }

Procedure DriversInit;
Var Temp : ExtStr;
Begin
 GetVideoMode(LastVideoMode);
 MouseInit;
 KeyboardInit;
 OKSound:=true;
 AppPath:=ParamStr(0);
 AppPath:=FExpand(AppPath);
 FSplit(AppPath,AppPath,AppName,Temp);
End;

Procedure DriversDone;
Begin
 KeyboardDone;
 MouseDone;
End;

END.

{                        Fin du Fichier UDrivers.Pas                        }
